//+------------------------------------------------------------------+
//|                                                      FullSSA.mq4 |
//|                                           Copyright  2007, klot |
//|                                                     klot@mail.ru |
//|                                                changes by mladen |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, klot"
#property copyright "mladen"
#property link      ""


#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import




#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 LimeGreen
#property indicator_color3 Orange
#property indicator_width2 2
#property indicator_width3 2
#property indicator_level1 0.0

//----
   extern string TimeFrame  = "Current time frame";
   extern int Lag=25;
   extern int NumComps=2;
   extern  int PeriodNorm=10;
   extern int N=400;
   extern double HighLowStep = 0.005;
   
   double arryTimeSeries[];
   double ssaWork[];
//---- buffers
double SSA[];
double max[];
double min[];

int    timeFrame;
string indicatorFileName;
bool   calculateValue;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,SSA);
   SetIndexBuffer(1,max);
   SetIndexBuffer(2,min);
      ArrayResize(arryTimeSeries,N);
      ArrayResize(ssaWork,N);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   ObjectDelete("Sell");
   ObjectDelete("Buy");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      int n = MathMin(Bars-1,N);   
      for(int i=n-1; i>=0; i--) 
      {
         double ma=iMA(NULL,0,PeriodNorm,0,MODE_SMA,PRICE_CLOSE,i);
         double dev=3*iStdDev(NULL,0,PeriodNorm,0,MODE_SMA,PRICE_CLOSE,i);
            if(dev==0) dev=0.1;
               arryTimeSeries[i]=(Close[i]-ma)/dev;
      }
   
      fastSingular(arryTimeSeries,n,Lag,NumComps,ssaWork);
         ArrayCopy(SSA,ssaWork);
            max[n-1]=SSA[n-1];
            min[n-1]=SSA[n-1];
            for(i=n-2; i>=0; i--)
            {
               max[i] = MathMax(SSA[i],max[i+1]-HighLowStep);
               min[i] = MathMin(SSA[i],min[i+1]+HighLowStep);
            }   
      
            int nmax=ArrayMaximum(SSA,3,1);
            int nmin=ArrayMinimum(SSA,3,1);
            if(nmax==2) { ObjectDelete("Sell"); ObjectCreate("Sell",OBJ_ARROW,0,Time[0],Open[0]); ObjectSet("Sell",OBJPROP_ARROWCODE,226); }
            if(nmin==2) { ObjectDelete("Buy");  ObjectCreate("Buy",OBJ_ARROW,0,Time[0],Open[0]);  ObjectSet("Buy",OBJPROP_ARROWCODE,225);  }
            
            SetIndexDrawBegin(0,Bars-n);
            return(0);
   }
   
   //
   //
   //
   //
   //
   
   int limit = MathMin(N*timeFrame/Period(),Bars-1);
   for(i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         SSA[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lag,NumComps,PeriodNorm,N,HighLowStep,0,y);
         max[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lag,NumComps,PeriodNorm,N,HighLowStep,1,y);
         min[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lag,NumComps,PeriodNorm,N,HighLowStep,2,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

